﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using System.Windows;

namespace XamTreeProblem
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application
    {
        
        private void StartUp(object sender, StartupEventArgs e)
        {
          
            var mainWindow = new MainWindow() { DataContext = new VM() };
            try
            {
                ((VM)mainWindow.DataContext).RegisterViews();
                mainWindow.Show();
            }
            catch(Exception ex)
            {
                //MessageBox.Show(ex.Message, "Error", MessageBoxButton.OK, MessageBoxImage.Error);
                Application.Current.Shutdown();
            }
        }
    }

    public abstract class ViewModelBase : INotifyPropertyChanged, INotifyCollectionChanged
    {
        protected ViewModelBase()
        {
        }


        // #region INotifyPropertyChanged

        /// <summary>
        /// Raised when a property on this object has a new value.
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged;

        /// <summary>
        /// Raises this object's PropertyChanged event.
        /// </summary>
        /// <param name="propertyName">The property that has a new value.</param>
        protected virtual void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                var e = new PropertyChangedEventArgs(propertyName);
                handler(this, e);
            }
        }

        // #endregion // INotifyPropertyChanged Members

        public virtual void RefreshContext()
        {

        }

        public virtual void OnShow()
        {
        }

        public virtual void OnHide()
        {
        }

        public event NotifyCollectionChangedEventHandler CollectionChanged;
    }
}
